package main

import (
	"os"
	"strings"
)

func writeService(m Metadata) error {
	f, err := os.Create("hapip/characteristic/service/apple_service_gen.go")
	if err != nil {
		return err
	}
	defer f.Close()

	_, err = f.WriteString(`// Code generated by cmd/generate/main.go; DO NOT EDIT.

package service

import (
	"code.pfad.fr/gohmekit/hapip"
	"code.pfad.fr/gohmekit/hapip/characteristic"
)
`)
	if err != nil {
		return err
	}

	type charProp struct {
		variableName string
		description  string
	}
	charMap := make(map[string]charProp)
	for _, c := range m.Characteristics {
		funcName := camelCase(c.Name)
		funcName = strings.ToLower(funcName[:1])[:1] + funcName[1:]
		charMap[c.UUID] = charProp{
			variableName: funcName,
			description:  c.Name + " (" + shortUUID(c.UUID) + ")",
		}
	}

	for _, s := range m.Services {
		txt := ""
		funcName := camelCase(s.Name)
		short := shortUUID(s.UUID)
		txt += "\nconst " + funcName + "_Type = \"" + short + "\"\n"

		requiredArgs := ""
		charsArgs := []string{}
		txt += "\n// " + funcName + " represents a " + s.Name + " service (" + shortUUID(s.UUID) + ")\n"
		if len(s.RequiredCharacteristics) > 0 {
			txt += "// Required characteristics:\n"
			for _, c := range s.RequiredCharacteristics {
				cp := charMap[c]
				txt += "//   - " + cp.variableName + ": " + cp.description + "\n"

				requiredArgs += cp.variableName + " hapip.Characteristic, "
				charsArgs = append(charsArgs, cp.variableName)
			}
			txt += "//\n"
		}
		if len(s.OptionalCharacteristics) > 0 {
			// TODO: optional characteristics
			txt += "// Optional characteristics:\n"
			for _, c := range s.OptionalCharacteristics {
				cp := charMap[c]
				txt += "//   - " + cp.description + "\n"
			}
			txt += "//\n"
		}
		txt += "// UUID: " + s.UUID + "\n"
		txt += "func " + funcName + "(" + requiredArgs + "optional ...hapip.Characteristic) characteristic.Service {\n"
		txt += "	chars := []hapip.Characteristic{" + strings.Join(charsArgs, ", ") + "}\n"
		txt += "	return characteristic.Service{\n"
		txt += "		Typ:            " + funcName + "_Type,\n"
		txt += "		Characteristic: append(chars, optional...),\n"
		txt += "	}\n"
		txt += "}\n"
		_, err = f.WriteString(txt)
		if err != nil {
			return err
		}
	}

	if err = f.Close(); err != nil {
		return err
	}
	return nil
}
